#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Feb  4 14:42:54 2019

@author: fernandez

This file is an auxiliary file called in the main file main.py
"""

import numpy as np
import h5py
import tensorflow as tf

#%%

def loadannS(path):      
    config = tf.ConfigProto(allow_soft_placement=True)
    sess = tf.Session(config=config)
    
    tf.saved_model.loader.load(sess,['tag'],path)
    graph = tf.get_default_graph()
    
    xp = graph.get_tensor_by_name('myxp:0')
    model = graph.get_tensor_by_name('mymodel:0')
    
    return sess,xp,model

def classEarb(f,th=[2,0.02],info=0):
    p = np.array(list(map(lambda x: (x[0]<th[0] or x[1]<th[1]),f)))[:,np.newaxis]*1
    return p

#%% Get data from randomly shuffled data in file data/datar.h5

def getstrain(k):
    data = h5py.File('data/datar.h5','r')
    strain = np.array(data[k]['strain'])
    data.close()
    return strain

def getannerror(path,k,ar):
    data = h5py.File('data/datar.h5','r')
    strain = np.array(data[k]['strain'])
    s = np.array(data[k]['stress_FE'])
    sess,xp,model = loadannS(path)
    sann = sess.run(model,{xp:strain})
    sess.close()
    tf.reset_default_graph()
    data.close()
    if ar=='a':
        return np.linalg.norm(s-sann,axis=1,keepdims=True)
    if ar=='r':
        return np.linalg.norm(s-sann,axis=1,keepdims=True)/np.linalg.norm(s,axis=1,keepdims=True)
    
def getannp(path,k,th):
    temp = np.hstack([
            getannerror(path,k,'a')
            ,getannerror(path,k,'r')
            ])
    return classEarb(temp,th=th)